package net.osgiliath.ws.client;

import java.util.List;


import net.osgiliath.dao.ValuesTestDao;
import net.osgiliath.entities.ValuesTest;
import org.apache.cxf.jaxrs.client.JAXRSClientFactory;
import org.springframework.stereotype.Component;

import net.osgiliath.ws.api.ValuesTestWsInterface;
@Component
public class ValuesTestWsClient implements ValuesTestDao {
	private ValuesTestWsInterface getWs() {
		java.util.Properties props = new java.util.Properties();
		java.net.URL url = null;
		try {
		
		url = ValuesTestWsClient.class.getClassLoader().getResource("server.properties");
		props.load(url.openStream());
		} catch (java.io.IOException e) {
			System.err.println("unexpected ioexception occured in ValuesTestWsInterface");
		} finally {
		return JAXRSClientFactory.create("http://"+props.getProperty("server.url")+":8080", ValuesTestWsInterface.class);
		}
		
	}
	@Override
	public ValuesTest findOne(Long arg0) {	
		return getWs().findOne(arg0);
	}
	@Override
	public List<ValuesTest> getAll() {
		List<ValuesTest> ret = getWs().getAll();
		for (ValuesTest it : ret) {
			it.setStringVal(it.getStringVal()+" with ws");
		}
		return ret;
	}
	@Override
	public void remove(Long arg0) {
		getWs().remove(arg0);
	}
	@Override
	public ValuesTest save(ValuesTest arg0) {
		return getWs().save(arg0);
	}
}
